'Frequenzanzeige_DRM.bas: Frequenzzhler mit neg. Offset 455 kHz, 08.02.2005, Wolfgang March
'**********************************************************************************************************************
'Hardware: LCD-Anzeige mit HD4478-kompatibler Schnittstelle
'          LCD-Verbindungen:
'          LCD01 an Masse (VSS)
'          LCD02 an +5V   (VDD)
'          LCD03 an Poti  (V0)
'          LCD04 an PB4   (RS)
'          LCD05 an Masse
'          LCD06 an PD6   (E)
'          LCD11 an PB3
'          LCD12 an PB2
'          LCD13 an PB1
'          LCD14 an PB0
'**********************************************************************************************************************
$regfile = "2313def.dat"                                    'Definitionsdatei wird eingebunden
$crystal = 20000000                                         'Quarz: 20,000MHz
'**********************************************************************************************************************
'Variablendefinition:
Dim Lcount As Long At &H60                                  'Zhler-Variable
Dim Wcountlo As Word At &H60 Overlay                        'LoWord der Zhlervariablen (Wert von Counter1)
Dim Wcounthi As Word At &H62 Overlay                        'HiWord der Zhlervariablen (berlaufwert von Counter1)
Dim Faktor As Byte At &H80                                  'Faktor fr Counter1-berlauf
Dim S As String * 8

'**********************************************************************************************************************
'LCD-Anzeige konfigurieren:
Config Lcd = 16 * 1                                         'wird wie 2 * 8 behandelt !!!
Config Lcdpin = Pin , Db4 = Portb.3 , Db5 = Portb.2 , Db6 = Portb.1 , Db7 = Portb.0 , E = Portd.6 , Rs = Portb.4

Ddrd.2 = 0                                                  'PD5/T1 auf Eingang setzen (Zhler-Eingang)

On Timer1 Oncounteroverflow                                 'Interrupt-Routine frs HiWord des Zhlerstands
Cls                                                         'LCD lschen
Cursor Off                                                  'LCD-Kursor ausschalten
Enable Interrupts                                           'generelle Interruptfreigabe
Enable Counter1                                             'Counter1 Interruptfreigabe
'**********************************************************************************************************************
'Hauptprogramm:
Main:
Faktor = 2                                                  'Startwert fr Zhlen Counter1-berlufe
$asm                                                        'Assembler starten
   LDI r25,&B00000111                                       'Counter1 (Zhler, fallende Flanke)
   Out &H2E , R25                                           'in TCCR1B schreiben und damit Starten
   ldi r21,198                                              'uere Schleife (198 Durchlufe)
   Label2:                                                  'Sprungmarke
   ldi r20,250                                              'innere Schleife
   Label1:                                                  '4 Takte, 250 Durchlufe
   dec r20                                                  'ergibt ca. 50s
   nop                                                      '4. Takt
   brne Label1                                              'Rcksprung, bis Register = 0
   dec r21                                                  'uere Schleife
   nop                                                      'Flltakt
   nop                                                      'Flltakt
   brne  Label2                                             'Rcksprung, bis Register = 0
'Wrde die uere Schleife 200 mal durchlaufen, wre die Torzeit etwas zu lang, deshalb wird sie
'nur 198 mal durchlaufen und die dadurch fehlende Torzeit durch die folgende Schleife korrigiert.
   ldi  r22,152                                             'R22 mit 152 laden und herunterzhlen.
   Label3:                                                  'Sprungmarke fr Schleife
   dec r22                                                  'R22 um 1 herunterzhlen
   nop                                                      'Flltakt
   nop                                                      'Flltakt
   brne label3                                              'Rcksprung, bis R22 = 0
'Korrekturzeit fr Auswirkung der Interrupts
   lds r23, &H80                                            'R23 mit Startwert laden
   Label5:                                                  'Sprungmarke ussere Schleife
   ldi r24, 47                                              '47 Durchlufe
   Label4:                                                  'Sprungmarke innere Schleife
   dec r24                                                  'R24 um 1 herunterzhlen
   brne  Label4                                             'Rcksprung, bis R24 = 0
   dec r23                                                  'R23 um 1 herunterzhlen
   brne label5                                              'Rcksprung, bis R23 = 0
'Ende der Interruptkorrekturschleife
   LDI r25,&B00000000                                       'alle Bits auf 0 fr TCCR1B
   Out &H2E , R25                                           'in TCCR1B schreiben und damit Counter anhalten
$end Asm                                                    'Assambler beenden
Wcountlo = Counter1                                         'Zhlerwert Bit 0 bis 15 bernehmen
Counter1 = 0                                                'Zhler lschen
Lcount = Lcount - 4550                                      ' - 4550 (ZF-Offset von 455,0 kHz abziehen)
S = Str(lcount)                                             'in String umwandeln
S = Format(s , "  0000.0")                                  'Formatieren fr Anzeige
Lcount = 0                                                  'Zhler-Variable zurcksetzen
Home Upper                                                  'linke 8 Stellen der LCD
Lcd S                                                       'Anzeige Zhlerwert mit eingefgtem Komma
Home Lower                                                  'rechte 8 Stellen der LCD
Lcd " kHz"                                                  'Anzeige Leerstelle und kHz
Goto Main                                                   'zurck zum Hauptprogrammanfang
'*********************************************************************************************************************
Oncounteroverflow:                                          'Interruptroutine fr Counter1-berlauf
  Decr Faktor                                               'Faktor bei Counter1-berlauf um 1 herunterzhlen
  Incr Wcounthi                                             'HiWord der Zhlervariablen erhhen (lCount=lCount+65536)
Return                                                      'Rcksprung ins Hauptprogramm